<?php
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';

/**
 * This class adds structure of 'audit_trail' table to 'gf5' DatabaseMap object.
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 * @see BasePeer
 * @see DatabaseMap
 * @package core.map
 */
class AuditTrailMapBuilder implements MapBuilder {

    /**
     * The name of this class
     */
    const CLASS_NAME = "core.map.AuditTrailMapBuilder";
	
    /**
     * The database map.
     */
    private $dbMap = null;

    /**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return true if this DatabaseMapBuilder is built
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

    /**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap("gf5");
		
		$tMap = $this->dbMap->addTable("audit_trail");
		$tMap->setPhpName("AuditTrail");
		
         
		$tMap->setUseIdGenerator(true);
		 
						
		 
		$tMap->setPrimaryKeyMethodInfo("audit_trail_audit_trail_id_seq");
		 
		
		// Add columns to map
		$tMap->addPrimaryKey("AUDIT_TRAIL_ID", "AuditTrailId", "int", CreoleTypes::INTEGER, true);
		$tMap->addColumn("CHANGE_DATE", "ChangeDate", "int", CreoleTypes::TIMESTAMP, false, null);
		$tMap->addForeignKey("USER_ID", "UserId", "int", CreoleTypes::INTEGER, "user" , "USER_ID", true);
		$tMap->addColumn("SECTION", "Section", "string", CreoleTypes::VARCHAR, false, 20);
		$tMap->addColumn("REF_ID", "RefId", "int", CreoleTypes::INTEGER, true, null);
		$tMap->addColumn("FIELD_NAME", "FieldName", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("NEW_VALUE", "NewValue", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("OLD_VALUE", "OldValue", "string", CreoleTypes::VARCHAR, false, null);
				
    }
}
