<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'core/User.php';
// (on-demand) include_once 'core/UserPeer.php';

include_once 'core/AuditTrailPeer.php';

/**
 * Base class that represents a row from the 'audit_trail' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to AuditTrail class. 
 * 
 * @package core 
 */
abstract class BaseAuditTrail extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var AuditTrailPeer
	 */
	protected static $peer;

	/**
	 * The value for the audit_trail_id field.
	 * @var int	  
	 */
	protected $audit_trail_id;	

	/**
	 * The value for the change_date field.
	 * @var int	  
	 */
	protected $change_date = -1;	

	/**
	 * The value for the user_id field.
	 * @var int	  
	 */
	protected $user_id;	

	/**
	 * The value for the section field.
	 * @var string	  
	 */
	protected $section;	

	/**
	 * The value for the ref_id field.
	 * @var int	  
	 */
	protected $ref_id = 0;	

	/**
	 * The value for the field_name field.
	 * @var string	  
	 */
	protected $field_name;	

	/**
	 * The value for the new_value field.
	 * @var string	  
	 */
	protected $new_value;	

	/**
	 * The value for the old_value field.
	 * @var string	  
	 */
	protected $old_value;	
  
	/**
	 * Get the AuditTrailId column value.
	 *  
	 * @return int	  
	 */
	public function getAuditTrailId()
	{
		return $this->audit_trail_id;
	}


	/**
	 * Set the value of `audit_trail_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setAuditTrailId($v)
	{
		if ($this->audit_trail_id !== $v) {
			$this->audit_trail_id = $v;
			$this->modifiedColumns[] = AuditTrailPeer::AUDIT_TRAIL_ID;
		}
				
	}


	/**
	 * Get the [optionally formatted] `change_date` column value.
	 *  
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getChangeDate($format = 'Y-m-d H:i:s')
	{
		if ($this->change_date === null || $this->change_date === '') {
			return null;
		} elseif (!is_int($this->change_date)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->change_date);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of change_date as date/time value: " . var_export($this->change_date, true));
			}
		} else {
			$ts = $this->change_date;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}


	/**
	 * Set the value of `change_date` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException - If passed [not-null] date/time is in an invalid format. 
	 */
	public function setChangeDate($v)
	{
		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for change_date from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->change_date !== $ts || $ts === -1) {
			$this->change_date = $ts;
			$this->modifiedColumns[] = AuditTrailPeer::CHANGE_DATE;
		}
		
	}

  
	/**
	 * Get the UserId column value.
	 *  
	 * @return int	  
	 */
	public function getUserId()
	{
		return $this->user_id;
	}


	/**
	 * Set the value of `user_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setUserId($v)
	{
		if ($this->user_id !== $v) {
			$this->user_id = $v;
			$this->modifiedColumns[] = AuditTrailPeer::USER_ID;
		}
			
		if ($this->aUser !== null && $this->aUser->getUserId() !== $v) {
			$this->aUser = null;
		}
			
	}

  
	/**
	 * Get the Section column value.
	 *  
	 * @return string	  
	 */
	public function getSection()
	{
		return $this->section;
	}


	/**
	 * Set the value of `section` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setSection($v)
	{
		if ($this->section !== $v) {
			$this->section = $v;
			$this->modifiedColumns[] = AuditTrailPeer::SECTION;
		}
				
	}

  
	/**
	 * Get the RefId column value.
	 *  
	 * @return int	  
	 */
	public function getRefId()
	{
		return $this->ref_id;
	}


	/**
	 * Set the value of `ref_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setRefId($v)
	{
		if ($this->ref_id !== $v || $v === 0) {
			$this->ref_id = $v;
			$this->modifiedColumns[] = AuditTrailPeer::REF_ID;
		}
				
	}

  
	/**
	 * Get the FieldName column value.
	 *  
	 * @return string	  
	 */
	public function getFieldName()
	{
		return $this->field_name;
	}


	/**
	 * Set the value of `field_name` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setFieldName($v)
	{
		if ($this->field_name !== $v) {
			$this->field_name = $v;
			$this->modifiedColumns[] = AuditTrailPeer::FIELD_NAME;
		}
				
	}

  
	/**
	 * Get the NewValue column value.
	 *  
	 * @return string	  
	 */
	public function getNewValue()
	{
		return $this->new_value;
	}


	/**
	 * Set the value of `new_value` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setNewValue($v)
	{
		if ($this->new_value !== $v) {
			$this->new_value = $v;
			$this->modifiedColumns[] = AuditTrailPeer::NEW_VALUE;
		}
				
	}

  
	/**
	 * Get the OldValue column value.
	 *  
	 * @return string	  
	 */
	public function getOldValue()
	{
		return $this->old_value;
	}


	/**
	 * Set the value of `old_value` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setOldValue($v)
	{
		if ($this->old_value !== $v) {
			$this->old_value = $v;
			$this->modifiedColumns[] = AuditTrailPeer::OLD_VALUE;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->audit_trail_id = $rs->getInt($startcol + 0);					
			$this->change_date = $rs->getTimestamp($startcol + 1, null);
			$this->user_id = $rs->getInt($startcol + 2);					
			$this->section = $rs->getString($startcol + 3);					
			$this->ref_id = $rs->getInt($startcol + 4);					
			$this->field_name = $rs->getString($startcol + 5);					
			$this->new_value = $rs->getString($startcol + 6);					
			$this->old_value = $rs->getString($startcol + 7);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating AuditTrail object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(AuditTrailPeer::DATABASE_NAME);
		$criteria->add(AuditTrailPeer::AUDIT_TRAIL_ID, $this->audit_trail_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(AuditTrailPeer::DATABASE_NAME);
		if ($this->isColumnModified(AuditTrailPeer::AUDIT_TRAIL_ID)) $criteria->add(AuditTrailPeer::AUDIT_TRAIL_ID, $this->audit_trail_id);
		if ($this->isColumnModified(AuditTrailPeer::CHANGE_DATE)) $criteria->add(AuditTrailPeer::CHANGE_DATE, $this->change_date);
		if ($this->isColumnModified(AuditTrailPeer::USER_ID)) $criteria->add(AuditTrailPeer::USER_ID, $this->user_id);
		if ($this->isColumnModified(AuditTrailPeer::SECTION)) $criteria->add(AuditTrailPeer::SECTION, $this->section);
		if ($this->isColumnModified(AuditTrailPeer::REF_ID)) $criteria->add(AuditTrailPeer::REF_ID, $this->ref_id);
		if ($this->isColumnModified(AuditTrailPeer::FIELD_NAME)) $criteria->add(AuditTrailPeer::FIELD_NAME, $this->field_name);
		if ($this->isColumnModified(AuditTrailPeer::NEW_VALUE)) $criteria->add(AuditTrailPeer::NEW_VALUE, $this->new_value);
		if ($this->isColumnModified(AuditTrailPeer::OLD_VALUE)) $criteria->add(AuditTrailPeer::OLD_VALUE, $this->old_value);
		return $criteria;			
	}
	
	

	/**
	 * @var User	  
	 */
	protected $aUser;

	/**
	 * Declares an association between this object and a User object
	 *
	 * @param User $v
	 * @return void
	 * @throws PropelException
	 */
	public function setUser($v)
	{
			
		if ($v === null) {
			$this->setUserId(NULL);
		} else {
			$this->setUserId($v->getUserId());
		}
   
		$this->aUser = $v;
	}


	/**
	 * Get the associated User object
	 *
	 * @param Connection Optional Connection object.
	 * @return User The associated User object.
	 * @throws PropelException
	 */
	public function getUser($con = null)
	{
		// include the Peer class
		include_once 'core/UserPeer.php';

		if ($this->aUser === null && ($this->user_id !== null)) {
	
			$this->aUser = UserPeer::retrieveByPK($this->user_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = UserPeer::retrieveByPK($this->user_id, $con);
			   $obj->addAuditTrails($this);
			 */
		}
		return $this->aUser;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setUserKey($key)
	{

		$this->setUserId( (int) $key);			
		
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("audit_trail_id", "change_date", "user_id", "section", "ref_id", "field_name", "new_value", "old_value", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case AuditTrailPeer::AUDIT_TRAIL_ID:
				return $this->getAuditTrailId();
				break;
		  
			case AuditTrailPeer::CHANGE_DATE:
				return $this->getChangeDate();
				break;
		  
			case AuditTrailPeer::USER_ID:
				return $this->getUserId();
				break;
		  
			case AuditTrailPeer::SECTION:
				return $this->getSection();
				break;
		  
			case AuditTrailPeer::REF_ID:
				return $this->getRefId();
				break;
		  
			case AuditTrailPeer::FIELD_NAME:
				return $this->getFieldName();
				break;
		  
			case AuditTrailPeer::NEW_VALUE:
				return $this->getNewValue();
				break;
		  
			case AuditTrailPeer::OLD_VALUE:
				return $this->getOldValue();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getAuditTrailId();
				break;
  
			case 1:
				return $this->getChangeDate();
				break;
  
			case 2:
				return $this->getUserId();
				break;
  
			case 3:
				return $this->getSection();
				break;
  
			case 4:
				return $this->getRefId();
				break;
  
			case 5:
				return $this->getFieldName();
				break;
  
			case 6:
				return $this->getNewValue();
				break;
  
			case 7:
				return $this->getOldValue();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(AuditTrailPeer::AUDIT_TRAIL_ID, $arr)) $this->setAuditTrailId($arr[AuditTrailPeer::AUDIT_TRAIL_ID]);
  
		if (array_key_exists(AuditTrailPeer::CHANGE_DATE, $arr)) $this->setChangeDate($arr[AuditTrailPeer::CHANGE_DATE]);
  
		if (array_key_exists(AuditTrailPeer::USER_ID, $arr)) $this->setUserId($arr[AuditTrailPeer::USER_ID]);
  
		if (array_key_exists(AuditTrailPeer::SECTION, $arr)) $this->setSection($arr[AuditTrailPeer::SECTION]);
  
		if (array_key_exists(AuditTrailPeer::REF_ID, $arr)) $this->setRefId($arr[AuditTrailPeer::REF_ID]);
  
		if (array_key_exists(AuditTrailPeer::FIELD_NAME, $arr)) $this->setFieldName($arr[AuditTrailPeer::FIELD_NAME]);
  
		if (array_key_exists(AuditTrailPeer::NEW_VALUE, $arr)) $this->setNewValue($arr[AuditTrailPeer::NEW_VALUE]);
  
		if (array_key_exists(AuditTrailPeer::OLD_VALUE, $arr)) $this->setOldValue($arr[AuditTrailPeer::OLD_VALUE]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case AuditTrailPeer::AUDIT_TRAIL_ID:
				$this->setAuditTrailId($value);
				break;
	  
			case AuditTrailPeer::CHANGE_DATE:
				$this->setChangeDate($value);
				break;
	  
			case AuditTrailPeer::USER_ID:
				$this->setUserId($value);
				break;
	  
			case AuditTrailPeer::SECTION:
				$this->setSection($value);
				break;
	  
			case AuditTrailPeer::REF_ID:
				$this->setRefId($value);
				break;
	  
			case AuditTrailPeer::FIELD_NAME:
				$this->setFieldName($value);
				break;
	  
			case AuditTrailPeer::NEW_VALUE:
				$this->setNewValue($value);
				break;
	  
			case AuditTrailPeer::OLD_VALUE:
				$this->setOldValue($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setAuditTrailId($value);
				break;
  
			case 1:
				$this->setChangeDate($value);
				break;
  
			case 2:
				$this->setUserId($value);
				break;
  
			case 3:
				$this->setSection($value);
				break;
  
			case 4:
				$this->setRefId($value);
				break;
  
			case 5:
				$this->setFieldName($value);
				break;
  
			case 6:
				$this->setNewValue($value);
				break;
  
			case 7:
				$this->setOldValue($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(AuditTrailPeer::DATABASE_NAME);

		try {
			$con->begin();
			AuditTrailPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(AuditTrailPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aUser !== null) {
				if ($this->aUser->isModified()) $this->aUser->save($con);
				$this->setUser($this->aUser);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = AuditTrailPeer::doInsert($this, $con);
					$this->setAuditTrailId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					AuditTrailPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return AuditTrailPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aUser !== null) {
				if (($retval = $this->aUser->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = AuditTrailPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed audit_trail_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setAuditTrailId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getAuditTrailId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return AuditTrail Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new AuditTrail();
		$copyObj->setChangeDate($this->change_date);
		$copyObj->setUserId($this->user_id);
		$copyObj->setSection($this->section);
		$copyObj->setRefId($this->ref_id);
		$copyObj->setFieldName($this->field_name);
		$copyObj->setNewValue($this->new_value);
		$copyObj->setOldValue($this->old_value);
		
		$copyObj->setNew(true);
		
		$copyObj->setAuditTrailId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return AuditTrailPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new AuditTrailPeer();
		}
		return self::$peer;
	}

}
