<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('html/SiteTemplate.php');
require_once('lib/GFConf.php');

class SiteAdminTemplate extends SiteTemplate {

	private $params;

	function header($params) {
		if (!isset($params['title'])) {
			Throw new exception('Missing title in project template');
		}
		$params['title']=' '.Language::getSessText('Tabs.Admin').' > '.$params['title'];
		$params['selectedtoptab']='admin';
		$this->params = $params;
		
		$this->addBreadCrumb('<a href="/gf/admin/">'.Language::getSessText('Tabs.Admin').'</a>');
		if (!Session::getSession()->isSiteAdmin()) {
			throw new PermissionDeniedException();
		}
		$this->checkLicenseAcceptance();
		return parent::header($params);
	}

	function checkLicenseAcceptance() {
		$etcDir = GFConf::get('system.etcDir');
		$file = $etcDir.'/license.accepted';
		
		if (!file_exists($file)) {
			if (isset($_REQUEST['license'])) {
			 	if (isset($_REQUEST['accept']) && $_REQUEST['accept'] == 'true') {
			 		file_put_contents($file, 'true');
			 		GFUrl::getUrl()->redirect($_REQUEST['url']);
			 	} else {
			 		$this->params['feedback']= Language::getSessText('License.DidntCheck');
					echo parent::header($this->params);
					$this->showLicense(true);
					echo parent::footer();
					exit();
			 	}
			} else {
				echo parent::header($this->params);
				$this->showLicense();
				echo parent::footer();
				exit();
			}
		}
	}

	function showLicense() {
		$libDir = GFConf::get('system.libDir');
		$url = $_SERVER['REQUEST_URI'];
		echo '<form action="'.$_SERVER['REQUEST_URI'].'" method="POST"><div align="center">';
		echo '<h3>'.Language::getSessText('License.Title').'</h3>';
		echo '<textarea cols="70" rows="20" readonly>';
		require_once($libDir.'/LICENSE');
		echo '</textarea><br /> <br />';
		echo '<input type="checkbox" name="accept" value="true"/> <strong>';
		echo Language::getSessText('License.IHaveRead').'</strong><br />';
		echo '<input type="hidden" name="url" value="'.$url.'"/>';
		echo HTMLWidget::button("submit",Language::getSessText('License.Accept'),"license","","") . '&nbsp;&nbsp; ';
		echo HTMLWidget::button("button",Language::getSessText('License.Decline'),"license_decline","","document.location.href='/';") . '&nbsp;&nbsp; ';
		echo '</form>';
	}
}

?>
