<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: GFPlugin.php 3226 2008-08-06 17:58:08Z bigdisk $
 * @author Tim Perdue tim@gforge.org
 * @date 2005-11-10
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

//require_once('PluginResult.php');

interface GFPlugin {
	
	const SITE_PLUGIN = 'site';
	const PROJECT_PLUGIN = 'project';
	const USER_PLUGIN = 'user';	

	/**
	 *	this is called when the first Action is called. Action manager 
	 *	gets the listeners for each plugin.
	 */
	function initialize();

	/**
	 *	Different types of plugins are possible -
	 *	GFPlugin::SITE_PLUGIN = 'site'
	 *	GFPlugin::PROJECT_PLUGIN = 'project'
	 *	GFPlugin::USER_PLUGIN = 'user'
	 */
	function getType();

	/**
	 *	get the name of this plugin. example: 'tracker'
	 *	@return	string
	 */
	function getName();

	/**
	 *	get the array of action names that this plugin answers to.
	 *	@return	array
	 */
	function getListeners();

	/**
	 *	handle action has a case statement to redirect the action to the appropriate function.
	 *	@param string
	 *	@param mixed
	 *	@return PluginResult
	 */
	function handleAction($listenername,$params);

	/**
	 *	take a search object and handle the search internally.
	 *	@param	GFSearch
	 *	@return PluginResult
	 */
	function search(GFSearch $search);

	/**
	 *
	 * /
	function getWSDL($server);
	*/

}

?>