<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Daniel A. Perez	daniel@gforgegroup.com
 * @date 2006-03-08
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once('plugins/docman/lib/DocmanFilePeer.php');
require_once('plugins/docman/lib/DocmanFile.php');
require_once('lib/core/Filesystem.php');
require_once('lib/core/FilesystemPeer.php');
require_once('plugins/docman/lib/InfoParser.php');
require_once('lib/html/HTMLWidget.php');
require_once('lib/html/association.php');
require_once('lib/html/TagsRenderer.php');
require_once('plugins/docman/lib/DocmanProjectSettingPeer.php');

$theme->header($params);
?>
<script type="text/javascript">

function toggle() {
	var element = document.getElementById("edit_area");
	if(element.style.display != "block") {
		element.style.display = "block";
	}
	else {
		element.style.display = "none";
	}
}

</script>

<form name="docedit" action="<?php echo GFUrl::getUrl()->currentBaseURL('DocmanFileEditAction') ?>" method="POST">
	<input type="hidden" name="id" value="<?php echo $id; ?>" />
	<table border="0">
	<tr>
		<td><img src="/images/docman_doc.gif" height="16" width="16" border="0">&nbsp;[#<?php echo $id ;?>] <?php echo $file->getLatestVersion()->getFile()->getFileName(); ?></td>
	</tr>
	<tr>
	<tr>
		<td><strong><?php echo $Lang->getText('Docman.Locked'); ?>:</strong><br /><?php echo (( $is_locked ) ? '&nbsp;<img alt="(locked)" src="/images/locked.png">' : '('.$Lang->getText('Docman.Unlocked').')' );?></td>
	</tr>
	<tr>
		<td><strong><?php echo $Lang->getText('Docman.DescriptionName'); ?>:</strong><br />
		<?php echo $description; ?></td>
	</tr>
</table>
</form>
<?php

/*
	Get the versions of docs
*/
$rs = DocmanFilePeer::doSelectDocumentVersionsRS($id);

$theader = array();
//$theader[]= $Lang->getText('Docman.Navigation');
$theader[] = $Lang->getText('Docman.Download');
$theader[] = $Lang->getText('Docman.Version');
$theader[] = $Lang->getText('Docman.ChangesName');
$theader[] = $Lang->getText('Docman.DateName');
$theader[] = $Lang->getText('Docman.Author');

echo "<p><h3>".$Lang->getText('Docman.Versions')."</h3></p>";
?>
<?php
	if ($file->userCanUpdate()) {
?>
<?php echo HTMLWidget::button("button","" .   $Lang->getText('Docman.Edit') . " ","cancel","","window.location = '" .   GFUrl::getUrl()->projectURL(GFUrl::getUrl()->getProject(),'DocmanFileEdit','docman','admin',array('id' => $file->getDocmanFileId())) . "'; ")?>
<?php
	} else {
?>
<?php echo HTMLWidget::button("button","" .   $Lang->getText('Docman.Edit') . " ","cancel","","window.location = '" .   GFUrl::getUrl()->projectURL(GFUrl::getUrl()->getProject(),'DocmanFileEdit','docman','admin',array('id' => $file->getDocmanFileId())) . "'; ", false)?>
<?php
	}
?>
<?php echo HTMLWidget::button("button","" .   $Lang->getText('Common.Back') . " ","cancel","","window.location = '" .   GFUrl::getUrl()->projectURL(GFUrl::getUrl()->getProject(),'','docman','',array('subdir' => $subdir)) . "'; ")?>

<div id="mainTabSet" class="tabber">
<div class="tabbertab<?php echo ((isset($_GET['selectedtab']) && $_GET['selectedtab']=='versions') ? ' tabbertabdefault' : ''); ?>" title="<?php echo $Lang->getText('Docman.Versions'); ?>" id="versionstab">
<?php

echo $theme->tableTop($theader);
$count=0;
while ($rs->next()) {
	
	$trow = array();
	$mods=array();
	$url = GFUrl::getURL()->downloadURL(DocmanFileVersion::SECTION,$rs->getInt('docman_file_version_id'),$rs->getInt('filesystem_id'),$rs->getString('file_name_safe'));
/*	if($count == 0) {
		$mods=array('rowspan="'.($rs->getRecordCount()).'"');
		$trow[]=$doctreerenderer->renderNavigation($subdir);
	}*/
	$trow[] = '<a href="'.$url.'"><img src="/images/docman_doc.gif" height="16" width="16" border="0">&nbsp;'.$rs->getString('file_name_safe').'</a>';	
	$trow[] = $rs->getInt('version_number');
	$trow[] = $rs->getString('changes');
	$trow[] = $rs->getDate('create_date');
	$trow[] = UserPeer::retrieveByPk($rs->getInt('created_by'))->getUserLink();
	echo $theme->tableRow($trow, $mods, true);
	//$count++;
}

if ($is_locked) {
	$button_enabled = false;
} elseif ($file->userCanCreate() && $file->userCanDelete()) {
	$button_enabled = true;
} else {
	$button_enabled = false;
};
echo $theme->tableBottom(array(GFUrl::getURL()->projectUrl($project,'DocmanFileVersionAdd','docman','',array('id'=>$id))=>$Lang->getText('Docman.AddNewVersion')),array($button_enabled));
$settings = DocmanProjectSettingPeer::retrieveByPk(GFUrl::getUrl()->getProject()->getProjectId());
?>
</div>
<?php
/*
//express removes the versioning and associations
if(!$settings || $settings->getShowAssociationsTab()){
?>
<div class="tabbertab<?php echo ((isset($_GET['selectedtab']) && $_GET['selectedtab']=='associations') ? ' tabbertabdefault' : ''); ?>" title="<?php echo $Lang->getText('Associations') ?>" id="associationstab">
<?php
	echo renderAssociationList(DocmanFile::SECTION,$file->getDocmanFileId(),$file->userCanUpdate(),$theme,$project);
?>
</div>
<?php

}

*/
if(!$settings || $settings->getShowTagsTab()){
?>
<div class="tabbertab<?php echo ((isset($_GET['selectedtab']) && $_GET['selectedtab']=='tags') ? ' tabbertabdefault' : ''); ?>" title="<?php echo $Lang->getText('Tag.TabHeader') ?>" id="tagstab">
<?php 
echo TagsRenderer::getTagsTable($file->getDocmanFileId(),DocmanFile::SECTION, $theme);

?>

</div>
<?php }?>
		
</div>
<?php

$theme->footer($params);
?>
