<?php
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';

/**
 * This class adds structure of 'forum_message' table to 'gf5' DatabaseMap object.
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 * @see BasePeer
 * @see DatabaseMap
 * @package plugins.forum.lib.map
 */
class ForumMessageMapBuilder implements MapBuilder {

    /**
     * The name of this class
     */
    const CLASS_NAME = "plugins.forum.lib.map.ForumMessageMapBuilder";
	
    /**
     * The database map.
     */
    private $dbMap = null;

    /**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return true if this DatabaseMapBuilder is built
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

    /**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap("gf5");
		
		$tMap = $this->dbMap->addTable("forum_message");
		$tMap->setPhpName("ForumMessage");
		
         
		$tMap->setUseIdGenerator(true);
		 
						
		 
		$tMap->setPrimaryKeyMethodInfo("forum_message_forum_message_id_seq");
		 
		
		// Add columns to map
		$tMap->addPrimaryKey("FORUM_MESSAGE_ID", "ForumMessageId", "int", CreoleTypes::INTEGER, true);
		$tMap->addForeignKey("FORUM_THREAD_ID", "ForumThreadId", "int", CreoleTypes::INTEGER, "forum_thread" , "FORUM_THREAD_ID", true);
		$tMap->addForeignKey("CREATED_BY", "CreatedBy", "int", CreoleTypes::INTEGER, "user" , "USER_ID", true);
		$tMap->addColumn("SUBJECT", "Subject", "string", CreoleTypes::VARCHAR, true, null);
		$tMap->addColumn("BODY", "Body", "string", CreoleTypes::VARCHAR, true, null);
		$tMap->addColumn("POST_DATE", "PostDate", "int", CreoleTypes::TIMESTAMP, false, null);
		$tMap->addColumn("PARENT_FORUM_MESSAGE_ID", "ParentForumMessageId", "int", CreoleTypes::INTEGER, false, null);
		$tMap->addColumn("MAIL_MSG_ID", "MailMsgId", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("MAIL_SENDER", "MailSender", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("IS_APPROVED", "IsApproved", "boolean", CreoleTypes::BOOLEAN, false, null);
				
    }
}
