<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for editing News
//
require_once('plugins/news/lib/NewsPeer.php');
require_once('plugins/news/lib/News.php');
require_once('exceptions/PermissionDeniedException.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/news/lib/html/NewsTemplate.php');
$theme = new NewsTemplate();

$Project = GFUrl::getUrl()->getProject();
$News = NewsPeer::retrieveByPk($_GET['id']);
if (!is_object($News) || !$News->userCanUpdate()) {
	throw new PermissionDeniedException();
}
$obj = $News;

$params = array(
		'project' => $Project,
	//	'News' => $News,
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'action' => isset($action) ? $action : '',
		'title' => $Lang->getText('News.EditPageTitle')
		);

$project_id = ( (isset($_POST) && isset($_POST['project_id'])) ? htmlspecialchars($_POST['project_id']) : $obj->getProjectId() );
$submitted_by = ( (isset($_POST) && isset($_POST['submitted_by'])) ? htmlspecialchars($_POST['submitted_by']) : $obj->getSubmittedBy() );
$is_approved = ( (isset($_POST) && isset($_POST['is_approved'])) ? htmlspecialchars($_POST['is_approved']) : $obj->getIsApproved() );
$post_date = ( (isset($_POST) && isset($_POST['post_date'])) ? htmlspecialchars($_POST['post_date']) : $obj->getPostDate() );
$summary = ( (isset($_POST) && isset($_POST['summary'])) ? htmlspecialchars($_POST['summary']) : $obj->getSummary() );
$details = ( (isset($_POST) && isset($_POST['details'])) ? htmlspecialchars($_POST['details']) : $obj->getDetails() );

include ('forms/NewsEdit-tpl.php');

?>