<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code lists News
//
require_once('plugins/news/lib/NewsPeer.php');
require_once('plugins/news/lib/News.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/news/lib/html/NewsTemplate.php');
$theme = new NewsTemplate();

$Project = GFUrl::getUrl()->getProject();

$params = array(
		'project' => $Project,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('News.BrowsePageTitle')
		);
$theme->header($params);

$columns = array(
	NewsPeer::POST_DATE => $Lang->getText('News.PostDateName'), 
	$Lang->getText('News.SummaryName'));

// Retrieve the objects array
$crit = new Criteria();
$crit->add(NewsPeer::PROJECT_ID, $Project->getProjectId());
$total = NewsPeer::doCount($crit);
$paginator = new Paginator('news', -1, $total, NewsPeer::POST_DATE, $columns);
$paginator->addPageClauses($crit);
$arr = NewsPeer::doSelect($crit);

/*$theader = array();
$theader[] = $Lang->getText('News.PostDateName');
$theader[] = $Lang->getText('News.SummaryName');*/
//$theader[] = $Lang->getText('News.DetailsName');

$theader = $paginator->getSortableTableHeaders($theme);
//echo $paginator->showLimitOptions();
echo $theme->tableTop($theader);

if (count($arr) == 0) {
	echo $theme->tableFullRow('<span class="nonefound">'.$Lang->getText('News.NoneFound').'</span>');
} else {
	foreach ($arr as $item) {
		$trow = array();
		$trow[0] = $item->getPostDate('Y-m-d');
		$trow[1] = 'Posted By: '.$item->getUser()->getUserLink().'<br />';
		$trow[1] .= '<a href="'. GFUrl::getUrl()->currentBaseUrl('NewsThreadView').'&amp;id='.$item->getNewsID() .'">'. $item->getSummary().'</a>';
		$trow[1] .= '<br /><br />';
		$trow[1] .= StringUtils::addHtmlLinks(nl2br($item->getDetails()));
		$trow[1] .= '<br /><br />';
		$trow[1] .= '<a href="'.GFUrl::getUrl()->projectUrl($params['project'],'NewsThreadView','news','',array('id'=>$item->getNewsId())).'"><img src="/images/forum_icon.gif" alt="" border="0" height="16" width="16">&nbsp;'.Language::getSessText('News.Discussions').'</a>';
		echo $theme->tableRow($trow,array(),true);
	}
	//echo $theme->listPaginatorRow($paginator);
}
if ($Project->getPermission()->isAdmin()) {
	$button_enabled = true;
} else {
	$button_enabled = false;
}
echo $theme->tableBottom(array(GFUrl::getURL()->projectUrl($Project,'NewsAdd','news','admin',array('return_to' => ''))=>$Lang->getText('News.AddNew')),array($button_enabled));

if(isset($paginator) && is_object($paginator)) {
	echo '<div class="paginator">' . $paginator->getPaginator() . '</div><br />';
}


$theme->footer($params);
?>
