<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: ScmCommitDetail.php 3226 2008-08-06 17:58:08Z bigdisk $
 * @author Tim Perdue tim@gforge.org
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('GFUrl.php');
require_once('plugins/scmcvs/lib/html/ScmCVSTemplate.php');
require_once('plugins/scm/lib/RepositoryBrowser.php');
require_once('plugins/scmcvs/lib/CVSRepository.php');

$project = GFUrl::getUrl()->getProject();
$scmplugin = $project->getPluginByName('scmcvs');
if (is_null($scmplugin)) {
	throw new InvalidPluginException('scmcvs');
}

$session = Session::getSession();
$lang = $session->getLanguage();

$template = new ScmCVSTemplate();

$params = array(
	'selectedbottomtab'	=> 'scmcvs',
	'project' => $project,
	'action' => isset($action) ? $action : '',
	'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
	'title' => $lang->getText('Scm.CommitDetails')
	);

// this shows the page from the generic SCM plugin
include_once('plugins/scm/wwwlib/ScmCommitDetail.php');
?>