<?php
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';

/**
 * This class adds structure of 'tracker_extra_field_data' table to 'gf5' DatabaseMap object.
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 * @see BasePeer
 * @see DatabaseMap
 * @package plugins.tracker.lib.map
 */
class TrackerExtraFieldDataMapBuilder implements MapBuilder {

    /**
     * The name of this class
     */
    const CLASS_NAME = "plugins.tracker.lib.map.TrackerExtraFieldDataMapBuilder";
	
    /**
     * The database map.
     */
    private $dbMap = null;

    /**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return true if this DatabaseMapBuilder is built
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

    /**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap("gf5");
		
		$tMap = $this->dbMap->addTable("tracker_extra_field_data");
		$tMap->setPhpName("TrackerExtraFieldData");
		
         
		$tMap->setUseIdGenerator(true);
		 
						
		 
		$tMap->setPrimaryKeyMethodInfo("tracker_extra_field_data_tracker_extra_field_data_id_seq");
		 
		
		// Add columns to map
		$tMap->addPrimaryKey("TRACKER_EXTRA_FIELD_DATA_ID", "TrackerExtraFieldDataId", "int", CreoleTypes::INTEGER, true);
		$tMap->addForeignKey("TRACKER_ITEM_ID", "TrackerItemId", "int", CreoleTypes::INTEGER, "tracker_item" , "TRACKER_ITEM_ID", true);
		$tMap->addColumn("FIELD_DATA", "FieldData", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addForeignKey("TRACKER_EXTRA_FIELD_ID", "TrackerExtraFieldId", "int", CreoleTypes::INTEGER, "tracker_extra_field" , "TRACKER_EXTRA_FIELD_ID", true);
				
    }
}
