<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for TrackerItem
//
require_once('plugins/tracker/lib/TrackerItemPeer.php');
require_once('plugins/tracker/lib/TrackerItem.php');
require_once('plugins/tracker/lib/html/TrackerExtraFieldRenderer.php');
require_once('GFUrl.php');
require_once('lib/exceptions/NotLoggedInException.php');

$session = Session::getSession();
if (!$session->isLoggedIn()) {
	throw new NotLoggedInException();
}
$Lang = $session->getLanguage();

require_once('plugins/tracker/lib/html/TrackerTemplate.php');
$theme = new TrackerTemplate();

$Project = GFUrl::getUrl()->getProject();
$tracker_id=$_REQUEST['tracker_id'];
$Tracker = TrackerPeer::retrieveByPk($tracker_id);
//check if user can create
$TrackerItem = new TrackerItem();
$Tracker->addTrackerItem($TrackerItem);
if (!$Tracker || !is_object($Tracker) || $Tracker->getProject()->getProjectId() != $Project->getProjectId() || !$TrackerItem->userCanCreate()) {
        throw new PermissionDeniedException();
}

$params = array(
		'project' => $Project,
		'tracker' => $Tracker,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('TrackerItem.AddNewPageTitle')
		);

//$tracker_id=((isset($_POST['tracker_id'])) ? htmlspecialchars($_POST['tracker_id']) : '' );
//$status_id=((isset($_POST['status_id'])) ? htmlspecialchars($_POST['status_id']) : '' );
$priority=((isset($_POST['priority'])) ? htmlspecialchars($_POST['priority']) : '' );
//$submitted_by=((isset($_POST['submitted_by'])) ? htmlspecialchars($_POST['submitted_by']) : '' );
$summary=((isset($_POST['summary'])) ? htmlspecialchars($_POST['summary']) : '' );
$details=((isset($_POST['details'])) ? htmlspecialchars($_POST['details']) : '' );

//$last_modified_date=((isset($_POST['last_modified_date'])) ? htmlspecialchars($_POST['last_modified_date']) : '' );
//$sort_order=((isset($_POST['sort_order'])) ? htmlspecialchars($_POST['sort_order']) : '' );
//$parent_id=((isset($_POST['parent_id'])) ? htmlspecialchars($_POST['parent_id']) : '' );

$tefr = new TrackerExtraFieldRenderer($Tracker);

//@TODO we will probably have to change this to adjust to the user's locale
if (!isset($_POST['start_date'])) {
	$start_date = date('M d Y');
} else {
	$start_date = $_POST['start_date'];
}

$next_week = (time() + (60*60*24*7));
if (!isset($_POST['end_date'])) {
	$end_date = date('M d Y', $next_week);
} else {
	$end_date = $_POST['end_date'];
}


include('forms/TrackerItemAdd-tpl.php');

?>
