<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for TrackerExtraField
//
require_once('plugins/tracker/lib/TrackerExtraFieldPeer.php');
require_once('plugins/tracker/lib/TrackerExtraField.php');
require_once('GFUrl.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/tracker/lib/html/TrackerAdminTemplate.php');
$theme = new TrackerAdminTemplate();

$Project = GFUrl::getUrl()->getProject();
$Tracker = TrackerPeer::retrieveByPk($_REQUEST['tracker_id']);
if (!is_object($Tracker) || !$Tracker->userIsAdmin()) {
	throw new PermissionDeniedException();
}

$params = array(
		'project' => $Project,
		'tracker' => $Tracker,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('TrackerExtraField.AddNewPageTitle')
		);

$tracker_id=$Tracker->getTrackerId();
$field_type=$_REQUEST['field_type'];
$field_name=((isset($_POST['field_name'])) ? htmlspecialchars($_POST['field_name']) : '' );
$field_type=((isset($_POST['field_type'])) ? htmlspecialchars($_POST['field_type']) : '' );
$attribute1=((isset($_POST['attribute1'])) ? htmlspecialchars($_POST['attribute1']) : '' );
$attribute2=((isset($_POST['attribute2'])) ? htmlspecialchars($_POST['attribute2']) : '' );
$is_required=((isset($_POST['is_required'])) ? htmlspecialchars($_POST['is_required']) : '' );
$alias=((isset($_POST['alias'])) ? htmlspecialchars($_POST['alias']) : '' );
$field_order=((isset($_POST['field_order'])) ? htmlspecialchars($_POST['field_order']) : '' );
$use_in_quick_browse=((isset($_POST['use_in_quick_browse'])) ? htmlspecialchars($_POST['use_in_quick_browse']) : '' );
$show_on_submit=((isset($_POST['show_on_submit'])) ? htmlspecialchars($_POST['show_on_submit']) : '' );
$default_value=((isset($_POST['default_value'])) ? htmlspecialchars($_POST['default_value']) : '' );

include('forms/TrackerExtraFieldAdd-tpl.php');

?>