<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

$theme->header($params);
echo '<p><div class="infobox">'.$Lang->getText('Tracker.AddTrackerDescription').'</div></p>';
?>
<p>
<strong>Tracker Options</strong>
<ul>
<li><a href="<?php echo GFUrl::getUrl()->currentBaseUrl('TrackerExtraFieldBrowse'); ?>&amp;tracker_id=<?php echo Validator::sanitizeInt($_REQUEST['tracker_id']); ?>"><?php echo $Lang->getText('TrackerExtraField.Edit'); ?></a></li>
<?php /* Commit triggers only in AS */ if (GFConf::get('system.licenseType')=='advanced') { ?>
<li><a href="<?php echo GFUrl::getUrl()->currentBaseUrl('TrackerCommitEdit', array('tracker_id' => Validator::sanitizeInt($_REQUEST['tracker_id']))); ?>"><?php echo $Lang->getText('Tracker.TrackerCommitEdit'); ?></a></li>
<?php } ?>
<li><a href="<?php echo GFUrl::getUrl()->currentBaseUrl('TrackerDelete'); ?>&amp;tracker_id=<?php echo Validator::sanitizeInt($_REQUEST['tracker_id']); ?>"><?php echo $Lang->getText('Delete'); ?></a></li>
</ul>
</p>
<br />
<p>
<strong><?php echo $Lang->getText('Tracker.EditPageTitle'); ?></strong>
</p>
<form action="<?php echo GFUrl::getUrl()->currentBaseURL('TrackerEditAction') ?>" method="post">
	<input type="hidden" name="tracker_id" value="<?php echo $_REQUEST['tracker_id']; ?>" />
	<?php if (isset($_REQUEST['redirect_to'])) { ?>
	<input type="hidden" name="redirect_to" value="<?php echo $_REQUEST['redirect_to'] ?>" />
	<?php } ?>

	<table border="0">
		<tr>
			<td><strong><?php echo $Lang->getText('Tracker.TrackerNameName'); ?>&nbsp;*</strong><br />
			<input type="text" name="tracker_name" value="<?php echo $tracker_name; ?>" /></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('Tracker.DescriptionName'); ?>&nbsp;*</strong><br />
			<input type="text" name="description" value="<?php echo $description; ?>" size="40" /></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('Tracker.IsPublicName'); ?></strong><br />
			<input type="checkbox" name="is_public" value="1" <?php echo (($is_public==1) ? 'checked="checked"' : '' ) ?>/></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('Tracker.RestrictBrowseName'); ?></strong><br />
			<input type="checkbox" name="restrict_browse" value="1" <?php echo (($restrict_browse==1) ? 'checked="checked"' : '' ) ?>/></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('Tracker.EmailAllUpdatesName'); ?></strong><br />
			<input type="checkbox" name="email_all_updates" value="1" <?php echo (($email_all_updates==1) ? 'checked="checked"' : '' ) ?>/></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('Tracker.EmailAddressName'); ?></strong><br />
			<input type="text" name="email_address" value="<?php echo $email_address; ?>" /></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('Tracker.DuePeriodName'); ?></strong><br />
			<input type="text" name="due_period" value="<?php echo ($due_period/(60*60*24)); ?>" size="3" maxlength="3" /></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('Tracker.SubmitInstructionsName'); ?></strong><br />
			<textarea name="submit_instructions" rows="10" cols="60"><?php echo $submit_instructions; ?></textarea></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('Tracker.BrowseInstructionsName'); ?></strong><br />
			<textarea name="browse_instructions" rows="10" cols="60"><?php echo $browse_instructions; ?></textarea></td>
		</tr>

		<tr>
			<td><strong><?php echo $Lang->getText('Tracker.ShowDependenciesTab'); ?></strong><br />
			<input type="checkbox" name="show_dependencies_tab" value="1" <?php echo ($show_dependencies_tab ? 'checked="checked"' : '' ) ?>/></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('Tracker.ShowDuplicatesTab'); ?></strong><br />
			<input type="checkbox" name="show_duplicates_tab" value="1" <?php echo ($show_duplicates_tab ? 'checked="checked"' : '' ) ?>/></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('Tabs.ShowAssociationsTab'); ?></strong><br />
			<input type="checkbox" name="show_associations_tab" value="1" <?php echo ($show_associations_tab ? 'checked="checked"' : '' ) ?> disabled="disabled"/></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('Tracker.ShowTimeTrackingTab'); ?></strong><br />
			<input type="checkbox" name="show_time_tracking_tab" value="1" <?php echo ($show_time_tracking_tab ? 'checked="checked"' : '' ) ?> disabled="disabled"/></td>
		</tr>
		<tr>
			<td><strong><?php echo $Lang->getText('Tabs.ShowTagsTab'); ?></strong><br />
			<input type="checkbox" name="show_tags_tab" value="1" <?php echo ($show_tags_tab ? 'checked="checked"' : '' ) ?>/></td>
		</tr>

		<tr>
			<td align="center">
				<?php echo HTMLWidget::button("submit","" .   $Lang->getText('submit.edit') . " ","submit","","")?>
				<?php echo HTMLWidget::button("button","" .   $Lang->getText('Common.Cancel') . " ","cancel","","window.location = '" .   GFUrl::getUrl()->projectURL(GFUrl::getUrl()->getProject(),'TrackerEdit','tracker','admin',array('tracker_id' => $Tracker->getTrackerId())) . "'; ")?>
			</td>
		</tr>
	</table>
</form>
<?php
$theme->footer($params);
?>
