<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   
 * @author Daniel A. Perez	daniel@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('html/SiteTemplate.php');
require_once('lib/core/ProjectPeer.php');
require_once('lib/core/UserPeer.php');
require_once('lib/core/User.php');
require_once('lib/core/RolePeer.php');
require_once('lib/core/Role.php');
require_once('lib/core/UserPeer.php');
require_once('plugins/wiki/lib/Wiki.php');
require_once('plugins/wiki/lib/html/WikiTemplate.php');

$theme = new WikiTemplate();
$project = GFUrl::getUrl()->getProject();

$pagename = (isset($_REQUEST['pagename'])) ? Validator::sanitizeString($_REQUEST['pagename']) : null;
$parent_page = (isset($_REQUEST['parent_page'])) ? Validator::sanitizeString($_REQUEST['parent_page']) : null;
$pageid = (isset($_REQUEST['pageid'])) ? Validator::sanitizeInt($_REQUEST['pageid']) : null;
$version = (isset($_REQUEST['version'])) ? Validator::sanitizeInt($_REQUEST['version']) : null;
$section = Project::SECTION;
$ref_id = $project->getProjectId();

$wiki = new Wiki($section,$ref_id,$theme,$project);

echo popupHeader($theme, 'Print Wiki Page');

?>
<script type="text/javascript">
	function printWikiPage() {
		document.getElementById('print_button_area').style.display = 'none';
		window.print();
		return;
	}

</script>
<?php
echo "\n<div id=\"print_button_area\">";
echo HTMLWidget::button("button","Print","button","","printWikiPage();");
echo "\n</div>";
$page = $wiki->retrievePageByName($pagename);
echo "\n".'<div style="float:left; clear:both; width:100%;">';
echo "\n".$page->getContents($page->getLatestVersionNumber());
echo "\n</div>";
echo "\n</div></div></body></html>";
?>
