<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code edits a ProjectJoinRequest and saves it to the 
// database
//
require_once('core/ProjectJoinRequest.php');
require_once('Validator.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('exceptions/InvalidDataException.php');
require_once('core/Language.php');

if ($_SERVER['REQUEST_METHOD'] != 'POST') {
	throw new PermissionDeniedException();
}

if (!isset($_POST['role_id']) && !isset($_REQUEST['reject'])) {
	GFUrl::redirect($url->currentBaseURL('ProjectJoinRequestBrowse'), array('feedback' =>Language::getSessText('ProjectJoinRequestException.NoRoleSelected')));

}

$Project = GFUrl::getUrl()->getProject();
if (!$Project->getPermission()->isAdmin()) {
	throw new PermissionDeniedException();
}

$user_id = Validator::sanitizeInt($_REQUEST['user_id']);

//
//	handle rejected user
//
if (isset($_REQUEST['reject'])) {
	$crit = new Criteria();
	$crit->add(ProjectJoinRequestPeer::PROJECT_ID,$Project->getProjectId());
	$crit->add(ProjectJoinRequestPeer::USER_ID,$user_id);
	$pjr = ProjectJoinRequestPeer::doSelectOne($crit);
	if (!is_object($pjr)) {
		throw new PermissionDeniedException();
	}
	//send a message notifying the user
	$pjr->sendRejectMessage();
	$pjr->delete();

	GFUrl::redirect($url->currentBaseURL('ProjectJoinRequestBrowse'), array('feedback' =>Language::getSessText('ProjectJoinRequest.EditFeedback')));
} else {

//
//	handle accepted user
//
	$role = new Role();

	$crit = new Criteria();
	$crit->add(ProjectJoinRequestPeer::PROJECT_ID,$Project->getProjectId());
	$crit->add(ProjectJoinRequestPeer::USER_ID,$user_id);
	$pjr = ProjectJoinRequestPeer::doSelectOne($crit);
	if (!is_object($pjr)) {
		throw new PermissionDeniedException();
	}

// saves the user to the project
	$user_project = new UserProject();
	$user_project->setUserId($user_id);
	$user_project->setProjectId($Project->getProjectId());
	$user_project->save();
	
// retrieves userproject_id info
	$crit = new Criteria();
	$crit->add(UserProjectPeer::USER_ID, $user_id);
	$crit->add(UserProjectPeer::PROJECT_ID, $Project->getProjectId());
	$saved_up = UserProjectPeer::doSelectOne($crit);

	$userProjectId = $saved_up->getUserProjectId();

// sets the role(s) for the new user-project assignation
	$roles_id = $_POST['role_id'];
	foreach ($roles_id as $role_id) {
		$user_project_role = new UserProjectRole();
		$user_project_role->setUserProjectId($userProjectId);
		$user_project_role->setRoleId(Validator::sanitizeInt($role_id));
		$user_project_role->save();
	}
	

	//send a message notifying the user
	$pjr->sendAcceptMessage();
	$pjr->delete();

	GFUrl::redirect($url->currentBaseURL('ProjectJoinRequestBrowse'), array('feedback' =>Language::getSessText('ProjectJoinRequest.EditFeedback')));

}


?>
