<?php
require_once('exceptions/InvalidDataException.php');
require_once('lib/core/TroveLink.php');
require_once('html/TroveRenderer.php');

$Project = GFUrl::getUrl()->getProject();
if (!$Project->userIsAdmin()) {
	// Only project admins can change member information
	throw new PermissionDeniedException();
}

try {
	$troveRenderer = new TroveRenderer();
	$troveRenderer->setSection(Project::SECTION);
	$troveRenderer->setRefId($Project->getPrimaryKey());
	$troveRenderer->savePOSTData();
	
	$feedback = $language->getText('TroveEdit.EditFeedback');
} catch (InvalidDataException $ex) {
	$feedback = '* '.implode('<br />* ', $errors);
}

include('TroveEdit.php');

?>
