<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('core/ProjectPeer.php');
require_once('session/Session.php');
require_once('core/Plugin.php');
require_once('plugin/GFPlugin.php');
require_once('core/RolePeer.php');
require_once('core/UserProject.php');
require_once('html/HTMLWidget.php');
require_once('html/StatsRenderer.php');

$session = Session::getSession();
$project = GFUrl::getUrl()->getProject();
$project_id = $project->getProjectId();
$Language = $session->getLanguage();

if (!isset($feedback)) {
	$feedback = '';
}

require_once('html/templates/ProjectReportingTemplate.php');
$template = new ProjectReportingTemplate();
$params = array(
		'project' => $project,
		'feedback' => $feedback,
		'title' => Language::getSessText('ProjectActivity.title')
	);
$template->header($params);
$begin=((isset($_REQUEST['start_date']) && strlen($_REQUEST['start_date']) > 5) ? $_REQUEST['start_date'] : 0 );
$end=((isset($_REQUEST['end_date']) && strlen($_REQUEST['end_date']) > 5) ? $_REQUEST['end_date'] : 0 );

if ($begin=="0") {
	$begin = (time()-(30*86400));
} else {
	$begin = strtotime($begin);
}
if ($end=="0") {
	$end = time();
} else {
	$end=strtotime($end)+86399;
}
if ($begin > $end) {
	$endtmp=$end;
	$end=$begin;
	$begin=$endtmp;
}
$ids = array();
$ids[] = 'scm';
$ids[] = 'trackeritem';
$ids[] = 'forum';

$texts=array();
$texts['scm']=$Language->getText('ProjectActivity.Commit');
$texts['trackeritem']=$Language->getText('ProjectActivity.TrackerItem');
$texts['forum']=$Language->getText('ProjectActivity.ForumPost');

if (!isset($_REQUEST['show'])) {
	$show=$ids;
} else {
	$show=$_REQUEST['show'];
}

if(!is_array($show)) Throw new Exception('Invalid Data Passed to query');

foreach ($show as $showthis) {
	if (array_search($showthis,$ids) === false) {
		Throw new Exception('Invalid Data Passed to query');
	}
}

$multiselect=HTMLWidget::multiSelectFromAssoc('show[]',$texts,$show,'',false,null,false,null,5);

$con = Propel::getConnection(UserPeer::DATABASE_NAME);
$stmt = $con->createStatement();

$sql="SELECT COUNT(*) FROM project_activity_vw WHERE activity_date 
	BETWEEN '".date('Y-m-d',$begin)." 00:00:00' AND '".date('Y-m-d',$end)." 23:59:59'
	AND project_id='".$project->getProjectId()."' AND section IN ('".implode("','",$show)."')";
$rs = $stmt->executeQuery($sql, ResultSet::FETCHMODE_NUM );
$rs->next();
$total = $rs->getInt(1);
$paginator = new Paginator('prjactivity', -1, $total, 'activity_date', array('activity_date'=>''));

$sql="SELECT * FROM project_activity_vw WHERE activity_date 
	BETWEEN '".date('Y-m-d',$begin)." 00:00:00' AND '".date('Y-m-d',$end)." 23:59:59'
	AND project_id='".$project->getProjectId()."' AND section IN ('".implode("','",$show)."') ".
	$paginator->getSQL();
	//ORDER BY activity_date DESC";
//echo $sql;
$rs = $stmt->executeQuery($sql);

	?>
<script language="javascript" type="text/javascript" src="/datetimepicker.js">
</script>
<br />
<table border="0" cellspacing="0" cellpadding="3" bgcolor="#E0E0E0">
<form action="<?php echo GFUrl::getUrl()->currentURL() ?>" method="post">
<tr>
	<td><strong><?php echo $Language->getText('ProjectActivity.HeaderActivity') ?></strong></td>
	<td><strong><?php echo $Language->getText('ProjectActivity.StartDate') ?></strong></td>
	<td><strong><?php echo $Language->getText('ProjectActivity.EndDate') ?></strong></td>
	<td></td>
</tr>
<tr>
	<td><?php echo $multiselect; ?></td>
	<td valign="top"><input id="startdate" name="start_date" value="<?php echo date('M d Y',$begin); ?>" size="11" maxlength="11" /><a href="javascript:NewCal('startdate','MMMddyyyy')"><img src="/themes/gforge5/images/cal.gif" width="16" height="16" border="0" alt="Pick a date"/></a></td>
	<td valign="top"><input id="enddate" name="end_date" value="<?php echo date('M d Y',$end); ?>" size="11" maxlength="11" /><a href="javascript:NewCal('enddate','MMMddyyyy')"><img src="/themes/gforge5/images/cal.gif" width="16" height="16" border="0" alt="Pick a date"/></a></td>
	<td valign="top"><?php echo HTMLWidget::button("submit", $Language->getText('Common.Submit'), "submit"); ?></td>
</tr>
</form>
</table>
<br />
<?php
	
	$renderer = new StatsRenderer($project, $rs, $paginator);
	echo $renderer->getStatsTable();
	echo '<div class="paginator" align="center">'.$paginator->getPaginator().'</div><br />';
	$template->footer();
?>
